import { fileURLToPath } from 'node:url'
import { configDefaults, defineConfig, mergeConfig } from 'vitest/config'
import viteConfig from './vite.config'

export default mergeConfig(
  viteConfig,
  defineConfig({
    test: {
      coverage: {
        exclude: [
          'src/main.ts',
        ],
      },
      environment: 'jsdom',
      exclude: [
        ...configDefaults.exclude,
        'e2e/**',
      ],
      root: fileURLToPath(new URL('./', import.meta.url)),
      typecheck: {
        checker: 'vue-tsc',
      },
    },
  }),
)
