import { Plugin } from 'ckeditor5/src/core'
import { ButtonView } from 'ckeditor5/src/ui'
import icon from '../img/IconifyField.svg'

export default class IconifyFieldUI extends Plugin {
  init() {
    const { editor } = this

    editor.ui.componentFactory.add('iconifyField', (locale) => {
      const buttonView = new ButtonView(locale)

      buttonView.set({
        label: editor.t('Icon'),
        icon,
        tooltip: true,
      })

      this.listenTo(buttonView, 'execute', () =>
        editor.execute('insertIconifyField'))

      return buttonView
    })
  }
}
